program PointsDarret;
 uses Robot1, Robot2, Robot3, Robot4, Robot5;
 
 {*******************************************************}
 {*                                                     *}
 {* "Premires leons de programmation en Turbo Pascal" *}
 {* Patrick, Laurent, Radhia et Thibault COUSOT         *}
 {* ditions McGraw-Hill, Paris, 1991.                  *}
 {* Points  d'arrt,  quadrillage  et  grillage  sur un *}
 {* cran rduit, page 193.                             *}
 {*                                                     *}
 {*******************************************************}

 { Dessiner la grille de tous les points d'arrts possibles du robot }
 
 procedure AuBord;
  { Avancer tout droit jusqu'au bord du cadre de dplacement }
  { du robot.                                                }
 begin
  while (not tb) do
   begin 
    av;
   end; 
 end;
 
 procedure VerticaleNordSud;
  { Le robot tant au bord nord orient vers le sud, marquer les }
  { points  d'arrt  sur la verticale et l'avancer vers l'est et }
  { le rorienter au nord, si possible.                          }
 begin
  dp;
  while (not tb) do
   begin
    av; dp;
   end;
  pqtd; 
  if not tb then
   begin
    av; pqtd; 
   end;
 end;
 
 procedure VerticaleSudNord;
  { Le robot tant au bord sud orient vers le nord, marquer les }
  { points  d'arrt  sur la verticale et l'avancer vers l'est et }
  { le rorienter au sud, si possible.                           }
 begin
  dp;
  while (not tb) do
   begin
    av; dp;
   end;
  pqtg; 
  if not tb then
   begin
    av; pqtg; 
   end;
 end;
 
 procedure dg;
 begin
  { Rejoindre le bord nord }
  lc; AuBord;
  { Rejoindre le coin nord-est }
  pqtd; AuBord;
  { Orienter le robot au sud }
  pqtd;
  { Marquer les verticales, d'est en ouest }
  while (not tb) do
   begin
    VerticaleNordSud;
    VerticaleSudNord;
   end;
  { Remettre le robot au centre orient vers le nord }
  ce; pn;
 end;

begin
 dg; st;
end.