program Quadrillage;
 uses Robot1, Robot2, Robot3, Robot4, Robot5;
 
 {*******************************************************}
 {*                                                     *}
 {* "Premires leons de programmation en Turbo Pascal" *}
 {* Patrick, Laurent, Radhia et Thibault COUSOT         *}
 {* ditions McGraw-Hill, Paris, 1991.                  *}
 {* Points  d'arrt,  quadrillage  et  grillage  sur un *}
 {* cran rduit, page 193.                             *}
 {*                                                     *}
 {*******************************************************}

 procedure AuBord;
  { Rejoindre le bord, tout droit }
 begin
  while (not tb) do
   begin
    av;
   end;
 end;

 procedure Rejoindre_Coin_Nord_Est;
 begin
  { Rejoindre le bord nord }
  lc; pn; AuBord;
  { Rejoindre le coin nord-est }
  pe; AuBord;
 end;

 procedure Verticale;
 { Le robot tant au bord nord, descendre en traant }
 { la verticale puis remonter.                       }
 begin
  { Orienter le robot vers le sud }
  ps;
  { Descendre en tracant la verticale }
  bc; AuBord;
  { Remonter du sud au nord }
  lc; pn; AuBord;
 end;

 procedure Tracer_Verticales;
  { Partant d'un robot au bord nord, tracer les verticales }
  { d'est  en  ouest  et  terminer  avec  le robot au coin }
  { nord-ouest.                                            }
 begin
  { Tracer la premiere verticale a l'est }
  Verticale;
  { Tracer les verticales suivantes, d'est en ouest }
  pw;
  while (not tb) do
   begin
    { Avancer  l'ouest }
    av;
    { Tracer la verticale }
    Verticale;
    pw;
   end;
 end;

 procedure Horizontale;
  { Le robot tant au bord ouest, traverser en traant }
  { l'horizontale  puis  retraverser pour rejoindre le }
  { bord ouest.                                        }
 begin
  { Orienter le robot vers l'est }
  pe;
  { Traverser en traant l'horizontale }
  bc; AuBord; lc;
  { Retraverser d'est en ouest }
  pw; AuBord;
end;

 procedure Tracer_Horizontales;
  { Partant  d'un  robot  au bord ouest tracer les horizontales }
  { d'est en ouest et terminer avec le robot au coin sud-ouest. }
 begin
  { Tracer la premiere horizontale au nord }
  Horizontale;
  { Tracer les horizontales suivantes, du nord au sud }
  ps;
  while (not tb) do
   begin
    { avancer au sud }
    av;
    { tracer l'horizontale}
    Horizontale;
    ps;
   end;
 end;

begin
 Rejoindre_Coin_Nord_Est;
 Tracer_Verticales;
 Tracer_Horizontales;
 st;
end.