program ArbreBinaire;
 uses Robot1, Robot2, Robot3, Robot4, Robot5;

 {*******************************************************}
 {*                                                     *}
 {* "Premires leons de programmation en Turbo Pascal" *}
 {* Patrick, Laurent, Radhia et Thibault COUSOT         *}
 {* ditions McGraw-Hill, Paris, 1991.                  *}
 {* ArbreBinaire, pages 248-249.                        *}
 {*                                                     *}
 {*******************************************************}

 procedure Arbre(L : integer);
  { Dessiner un arbre  L feuilles, la racine en haut, les feuilles }
  { en bas, en supposant que L >= 1,  l'arbre  tant  rduit    un }
  { point quand L = 1. Avant et aprs le dessin, le robot doit tre }
  { plac    la racine de l'arbre, orient au nord avec son crayon }
  { baiss.                                                         }
 begin
  if (L = 1) then
   begin
    { Dessiner  un  arbre  rduit   un seul point (sans changer la }
    { position et l'orientation du robot).                          }
    dp;
   end
  else { L > 1 }
   begin
    { Le robot tant plac  la racine de l'arbre,  orient au nord }
    { avec son crayon baiss, dessiner la branche sud-ouest.        }
    p3htg; avf(L); 
    { Orienter le robot au nord.                                    }
    p3htd;
    { Dessiner le sous-arbre gauche ayant  (L div 2) >= 1 feuilles, }
    { le  robot  tant  plac  la racine du sous-arbre, orient au }
    { nord avec son crayon baiss.                                  }
    Arbre(L div 2); 
    { Sachant que le robot est plac  la racine du sous-arbre gau- }
    { che, orient au nord et crayon baiss, revenir  la racine de }
    { l'arbre, sans rien dessiner.                                  }
    lc; phtd; avf(L); 
    { Le robot tant plac  la racine de l'arbre, orient au nord- }
    { est avec son crayon lev, dessiner la branche sud-est.        }
    bc; pqtd; avf(L); 
    { Orienter le robot au nord.                                    }
    p3htg; 
    { Dessiner le  sous-arbre  droit  ayant  (L - (L div 2))  >=  1 }
    { feuilles,  le  robot  tant  plac  la racine du sous-arbre, }
    { orient au nord avec son crayon baiss.                       }
    Arbre(L - (L div 2)); 
    { Placer le robot  la racine de l'arbre,  orient au nord avec }
    { son crayon baiss.                                            }
    lc; phtg; avf(L); phtd; bc; 
   end;
 end;

begin
 lgX(2); lgY(3); eh; Arbre(32); st;
end.