program BateauAVoilesComplet;
 uses Robot1, Robot2, Robot3, Robot4, Robot5;
 
 {*******************************************************}
 {*                                                     *}
 {* "Premires leons de programmation en Turbo Pascal" *}
 {* Patrick, Laurent, Radhia et Thibault COUSOT         *}
 {* ditions McGraw-Hill, Paris, 1991.                  *}
 {* Exercice 43, page 274.                              *}
 {*                                                     *}
 {*******************************************************}

 { Dessiner un bateau  voiles  completer }
 
 { Mmorisation de la direction courante du robot }
 var
  OrientationCourante : integer;
 
 procedure MemoriserDirection;
  { Mmoriser la direction courante du robot dans 'OrientationCourante' }
 begin
  OrientationCourante := valOrientation;
 end;
 
 procedure ReprendreDirection;
  { Mettre le robot dans la direction mmorise dans 'OrientationCourante' }
 begin
  Pivoter(OrientationCourante);
 end;
 
 { Mmorisation de la taille de la grille }
 var
  TailleHorizontale : real;
  TailleVerticale   : real;
 
 procedure MemoriserTailleGrille;
 begin
  TailleHorizontale := ValLGX;
  TailleVerticale   := ValLGY;
 end;
 
 procedure ReprendreTailleGrille;
 begin
  lgx(TailleHorizontale);
  lgy(TailleVerticale);
 end;
 
 { Mmorisation de la position du crayon }
 var
  CrayonBaisse : boolean;
 
 procedure MemoriserPositionCrayon;
 begin
  CrayonBaisse := ValBC;
 end;
 
 procedure ReprendrePositionCrayon;
 begin
  if CrayonBaisse then
   begin
    bc;
   end
  else
   begin
    lc;
   end;
 end;
 
 { Mmoriser le numro de la position courante du robot }
 var
  Numero : integer;
  
 procedure NumeroterE;
  { Marquer d'une croix la position courante du robot, la numroter }
  {   l'est  avec  la  valeur de 'Numero' qui est increment, sans }
  { changer la position et l'orientation du robot. }
 begin
  dc;
  MemoriserDirection; MemoriserTailleGrille; MemoriserPositionCrayon;
  lg(ValEC + 3); pe; lc; av; Ecrire(EntierEnChaine(Numero)); pdt; av;
  ReprendreDirection; ReprendreTailleGrille; ReprendrePositionCrayon;
  Numero := Numero + 1;
 end;
 
 procedure NumeroterW;
  { Marquer d'une croix la position courante du robot, la numroter }
  {   l'ouest  avec la valeur de 'Numero' qui est increment, sans }
  { changer la position et l'orientation du robot. }
 begin
  dc;
  MemoriserDirection; MemoriserTailleGrille; MemoriserPositionCrayon;
  lg(ValEC + 10); pw; lc; av; Ecrire(EntierEnChaine(Numero)); pdt; av;
  ReprendreDirection; ReprendreTailleGrille; ReprendrePositionCrayon;
  Numero := Numero + 1;
 end;

begin
{ Initialisation }
 lg(12); ec(2); dg;
 PoliceTexte(PetitePolice); TailleTexte(8); Numero := 0;
{ Dplacer le robot en bas sans rien dessiner }
  lc; pdt; avf(10); NumeroterE; pqtg; 
{ Dessiner l'arriere de la coque }
  { Dessiner la ligne de flotaison arrire }
    bc; avf(9); NumeroterE; 
  { Dessiner l'arrire de la coque }
    phtg; avf(4); NumeroterE; 
  { Dessiner le pont arrire }
    pqtg; phtg; avf(13); NumeroterE; 
{ Dessiner le mt }
  pqtd; avf(16); NumeroterE; 
{ Dessiner le drapeau }
  pqtd; avf(4); NumeroterE; pqtd; avf(2); NumeroterE; pqtd; avf(4); 
  NumeroterE; pqtg; av; NumeroterE; 
{ Dessiner la grand voile }
  phtg; avf(12); NumeroterE; 
  pqtd; phtd; avf(12);
{ Dessiner le foc }
  avf(9); NumeroterE; pqtd; phtd; 
  avf(9); NumeroterE; pqtd; phtd; 
  avf(10); NumeroterW; pqtd; 
{ Dessiner l'avant du bateau} 
  { Dessiner le pont avant }
    avf(10); NumeroterE; 
  { Dessiner l'avant de la coque }
    pdt; phtd; avf(4); NumeroterE; 
  { Dessiner la ligne de flotaison avant }
    phtg; avf(6); NumeroterW; 
 st; 
end.