program ChienComplet;
 uses Robot1, Robot2, Robot3, Robot4, Robot5;

 {*******************************************************}
 {*                                                     *}
 {* "Premires leons de programmation en Turbo Pascal" *}
 {* Patrick, Laurent, Radhia et Thibault COUSOT         *}
 {* ditions McGraw-Hill, Paris, 1991.                  *}
 {* Exercice 43, page 274.                              *}
 {*                                                     *}
 {*******************************************************}

 { Dessin d'un chien  complter }

 { Mmorisation de la direction courante du robot }
 var
  OrientationCourante : integer;

 procedure MemoriserDirection;
  { Mmoriser la direction courante du robot dans 'OrientationCourante' }
 begin
  OrientationCourante := valOrientation;
 end;

 procedure ReprendreDirection;
  { Mettre le robot dans la direction mmorise dans 'OrientationCourante' }
 begin
  Pivoter(OrientationCourante);
 end;

 { Mmorisation de la taille de la grille }
 var
  TailleHorizontale : real;
  TailleVerticale   : real;

 procedure MemoriserTailleGrille;
 begin
  TailleHorizontale := ValLGX;
  TailleVerticale   := ValLGY;
 end;

 procedure ReprendreTailleGrille;
 begin
  lgx(TailleHorizontale);
  lgy(TailleVerticale);
 end;

 { Mmorisation de la position du crayon }
 var
  CrayonBaisse : boolean;

 procedure MemoriserPositionCrayon;
 begin
  CrayonBaisse := ValBC;
 end;

 procedure ReprendrePositionCrayon;
 begin
  if CrayonBaisse then
   begin
    bc;
   end
  else
   begin
    lc;
   end;
 end;

 { Mmoriser le numro de la position courante du robot }
 var
  Numero : integer;

 procedure NumeroterE;
  { Marquer d'une croix la position courante du robot, la numroter }
  {   l'est  avec  la  valeur de 'Numero' qui est increment, sans }
  { changer la position et l'orientation du robot. }
 begin
  dc;
  MemoriserDirection; MemoriserTailleGrille; MemoriserPositionCrayon;
  lg(ValEC + 3); pe; lc; av; Ecrire(EntierEnChaine(Numero)); pdt; av;
  ReprendreDirection; ReprendreTailleGrille; ReprendrePositionCrayon;
  Numero := Numero + 1;
 end;

 procedure NumeroterW;
  { Marquer d'une croix la position courante du robot, la numroter }
  {   l'ouest  avec la valeur de 'Numero' qui est increment, sans }
  { changer la position et l'orientation du robot. }
 begin
  dc;
  MemoriserDirection; MemoriserTailleGrille; MemoriserPositionCrayon;
  lg(ValEC + 10); pw; lc; av; Ecrire(EntierEnChaine(Numero)); pdt; av;
  ReprendreDirection; ReprendreTailleGrille; ReprendrePositionCrayon;
  Numero := Numero + 1;
 end;

 { Mmorisation de la taille du crayon }
 var
  TailleCrayon : integer;

 procedure MemoriserTailleCrayon;
 begin
  TailleCrayon := ValEC;
 end;

 procedure ReprendreTailleCrayon;
 begin
  ec(TailleCrayon);
 end;

begin
 { Initialisation }
 eb; lg(18); ec(2); dg;
 PoliceTexte(PetitePolice); TailleTexte(7); Numero := 0; NumeroterE;
 { Profil arrire de la patte avant }
 avf(2); NumeroterE; pqtd;
 { Ventre }
 avf(3); NumeroterE; vg; NumeroterE;  
 { Patte arrire }
 pdt; avf(3); NumeroterE; pqtg; av; NumeroterE; pqtg; avf(4); 
 { Queue }
 avf(2); NumeroterE; vd; NumeroterE; pdt; vg; vd; NumeroterE; 
 { Dos }
 avf(3); NumeroterE; vd; NumeroterE; 
 { Tte }
  { Oreille }
  av; av; NumeroterE; pqtg; av; NumeroterE; pqtg; av; NumeroterE; 
  { Oeil }
  lc; av; MemoriserTailleCrayon; ec(4); dp; ReprendreTailleCrayon; pdt; av; bc;
  pqtg; av; NumeroterE; pqtg; av; NumeroterE; 
  { Museau }
  pqtd; avf(2); NumeroterE; pqtg; avf(2); NumeroterE; pqtg; 
  { Gueule }
  vg; NumeroterE; pdt; vd; NumeroterW; pdt; avf(2); NumeroterE; vd; NumeroterE; 
 { Profil avant de la patte avant }
 avf(3); NumeroterW; pqtg; av; NumeroterW; 
 st;
end.